const path = require("path")
const root = path.resolve(__dirname, '../../')


const __glob = {
    CONFIG:  root + path.sep + "data" + path.sep + "config.json",
    USERS:  root + path.sep + "data" + path.sep + "users.json",
    BETA_USERS:  root + path.sep + "data" + path.sep + "betas.json",
    ROOT: root,
    WEB_DIR: root + path.sep + "src" + path.sep + "web",
    COMMANDS: root + path.sep + "src" + path.sep + "commands",
    SUBLOG: root + path.sep + "src" + path.sep + "modules" + path.sep + "sub-log.js",
    SUBPLAYER: root + path.sep + "src" + path.sep + "modules" + path.sep + "sub-player.js",
    SUBLIST: root + path.sep + "src" + path.sep + "modules" + path.sep + "sub-list.js",
    DISCORDBOT: root + path.sep + "src" + path.sep + "modules" + path.sep + "discord-bot.js",
    PACKAGE: root + path.sep + "package.json",
    DATA:  root + path.sep + "data" + path.sep,
    NODES:  root + path.sep + "data" + path.sep + "nodes.json",
    README: root + path.sep + "README.md",
    PLAYLIST:  root + path.sep + "data" + path.sep + "playlist.json",
    RADIO:  root + path.sep + "data" + path.sep + "radios.json",
    LOGS: root + path.sep + "src" + path.sep + "modules" + path.sep + "logs"
};

const webroot = __glob.WEB_DIR + path.sep 
const __web = {

    ROUTER: webroot + "routes" + path.sep,
    PUBLIC: webroot + "public",
    TEMPLATES: webroot + "templates",  
    ICON: webroot + "public" + path.sep + "images" + path.sep + "logo.ico"
}

module.exports = { __glob, __web };

