var wasOnNodes = false

settingsBtn.addEventListener("click", () => {

    wasOnHome = false

    mainView.innerHTML = `
    <div class="SETTINGS">
        <div class='ssidebar'>
            <div id="settings_logs" class="sside_line"><i class="fa-solid fa-newspaper"></i> Logs</div>
            <div id="settings_connexion" class="sside_line"><i class="fa-solid fa-tower-cell"></i> Connexions</div>
            <div id="settings_users" class="sside_line"><i class="fa-solid fa-people-group"></i> Utilisateurs</div>
        </div>
        <div id="settings_content" class='SETTINGS_content'>
            <div class=""><i class="fa fa-search"></i> Logs</div>
        </div>  
    </div>
    `

    const settings_logs = document.getElementById("settings_logs")
    const settings_connexion = document.getElementById("settings_connexion")
    const settings_users = document.getElementById("settings_users")
    const settings_content = document.getElementById("settings_content")

    loadLogs()

    settings_logs.addEventListener("click", () => {
        loadLogs()
        wasOnNodes = false
    })

    settings_connexion.addEventListener("click", () => {
        loadConnexion()
        wasOnNodes = true
    })

    settings_users.addEventListener("click", () => {
        loadUsers()
        wasOnNodes = false
    })

    settings_logs.style.color = "white"

    function loadUsers() {
       
        socket.emit("GET/USERS")
    
    }

    function loadLogs() {
        settings_content.innerHTML = `
            <select id="logs_selection">
                <option>NOT CONNECTED</option>
            </select>
            </div>
            <div id="logs_content" class="logs_content">
        

            </div>

        `

        const logs_selection = document.getElementById("logs_selection")
        const logs_content = document.getElementById("logs_content")

        const logs_data = get("LOGS")

        logs_data.then(data => {

            
            var optionToPush = new Array()
            for(var log of data) {
                optionToPush.push("<option>" + log.name + "</option>")
            }

            logs_selection.innerHTML = optionToPush.reverse().join("")

            for(var log of data) {

                if(logs_selection.value == log.name) {

                    var logToPush = new Array()

        

                        for(var line of log.value.split("\n")) {

                            line.toString()
                     
                            
                            line = line.replace("[INFO]", "<span style='color: #41f2ff !important;'>[INFO]</span>")
                                        .replace("[ERROR]", "<span style='color: #ff3232;'>[ERROR]</span>")
                                        .replace("[WARN]", "<span style='color: #ffea00;'>[WARN]</span>")
                                        .replace("[FATAL]", "<span style='color: red;'>[FATAL]</span>")
                                        .replace("[STEP]", "<span style='color: #ff6bf5;'>[STEP]</span>");

                            logToPush.push("<p class='log_line'>" +line+ "</p>")
                            
                        }

                 
                        
                    logs_content.innerHTML = logToPush.join("")
                } 

            }

            logs_selection.addEventListener("change", () => {
                
                for(var log of data) {

                    if(logs_selection.value == log.name) {

                        var logToPush = new Array()

                        for(var line of log.value.split("\n")) {                   
                            
                            line.toString()
                     
                            
                            line = line.replace("[INFO]", "<span style='color: #41f2ff !important;'>[INFO]</span>")
                                        .replace("[ERROR]", "<span style='color: #ff3232;'>[ERROR]</span>")
                                        .replace("[WARN]", "<span style='color: #ffea00;'>[WARN]</span>")
                                        .replace("[FATAL]", "<span style='color: red;'>[FATAL]</span>")
                                        .replace("[STEP]", "<span style='color: #ff6bf5;'>[STEP]</span>");

                            

                            logToPush.push("<p class='log_line'>" + line + "</p>")
                            
                        }

                 
                        
                        logs_content.innerHTML = logToPush.join("")
                    }

                }

            })
            
        })

    }

    function loadConnexion() {
        

        socket.emit("GET/NODES")

    }



    const buttons = document.querySelectorAll(".sside_line");

    buttons.forEach(button => {
        button.addEventListener("click", function () {
            buttons.forEach(btn => {
                if (btn === button) {
                    btn.style.color = "white";
                } else {
                    btn.style.color = "";
                }
            });
        });
    });
})


socket.on("ALWAYS/USERS",(data) => {

    const settings_content = document.getElementById("settings_content")

    if(settings_content) {

        var userToPush = new Array()

        console.log(data)
    
        for(var user of data) {
    
            var admin_bar = ''
    
            if(user.beta == true) {
    
                admin_bar = "<div><p>BETA</p></div>"
            }
            
            userToPush.push("<div class='set_user'><div class='set_user_info'><img src='https://cdn.discordapp.com/avatars/" + user.user.id + "/" + user.user.avatar + "'><div style='display: flex; flex-direction: column; justify-content: center;'><p class='INDEX_gbname'>" + user.user.global_name + "</p><p class='INDEX_usrname'>" + user.user.username + "</p></div>" + admin_bar + "</div><div style='font-size: 25px;'><button id='" + data.indexOf(user) +  "_uadmin' style='margin: 0 !important;' class='list_upSong'><i class='fa fa-star'></i></button><button id='" + data.indexOf(user) +  "_udelete' class='list_delete'><i class='fa fa-trash'></i></button></div></div>")
            
        }
    
    
        settings_content.innerHTML = userToPush.join("")
       
    
    
        
        for(var user of data) {
    
    
            let adminBtn = document.getElementById(data.indexOf(user) + "_uadmin")
            let deleteBtn = document.getElementById(data.indexOf(user) + "_udelete") 
    
            if(data[adminBtn.id.replace("_uadmin", "")].admin == true) {
    
    
                adminBtn.style.color = "#d2bd19"
    
            } 
    
            adminBtn.addEventListener("click", () => { 
    
                send("USERS/ADMIN", data[adminBtn.id.replace("_uadmin", "")])
    
                socket.emit("GET/USERS")
            })
            
            deleteBtn.addEventListener("click", () => {
    
    
                send("USERS/DELETE", data[adminBtn.id.replace("_uadmin", "")])
    
                socket.emit("GET/USERS")
            })
         }
         
    }

    



})

socket.on("ALWAYS/NODES",(data) => {

    const settings_content = document.getElementById("settings_content")

    if(settings_content && wasOnNodes) {

        var dataToPush = new Array()

        dataToPush.push(`<div style='width: 100%; display: flex; justify-content: space-between; align-items: center;'>
        <div><p><strong>Note : </strong> Les serveurs ci-dessous permettent le bon fonctionnement du Bot.</p>
             <p>Si aucun des serveurs ne fonctionne, ajoutez-en en prenant ce lien pour la liste des serveurs : <a style='color: white' target='_blank' href="https://lavalink.darrennathanael.com/SSL/lavalink-with-ssl/"><strong>Lavalink SSL</strong></a></div>
        <button id='an_create' class='primary'><i class='fa fa-plus'></i></button></div><hr>`)

        dataToPush.push(`
        <dialog class="report_dialog" id="an_dialog">
            <div class="rlineclose">
                <p class="rtitle"><i class="fa fa-wifi"></i> Ajout d'une connexion Lavalink</p>
                <button id="an_close" class="report_close"><i class="fa-solid fa-xmark"></i></button>
            </div>
            <p id='an_info' style='text-align: center; color: red;'></p>

            <div class="rcontent">
                <p class="runder">Host</p>
                <input type='text' id="an_host">
                <p class="runder">Port</p>
                <input type='number' id="an_port">
                <p class="runder">Mot de passe</p>
                <input type='text' id="an_password">
                <button id="an_send" class="rsend"><i class="fa-solid fa-plus"></i> Ajouter</button>
            </div>
        </dialog>


        `)

        console.log(data)
    
        for(var node of data) {

            var stateInput = "<p class='connexion_logo_off'>Déconnecté</p>"
            
            if(node.state == true) {

                stateInput = "<p class='connexion_logo_on'>Connecté</p>"
            }

            dataToPush.push(`  
            <div class='connexion_div'>
                <div class='connexion_info'>
                    <div class='connexion_logo'>
                        <i class='fa fa-wifi'></i>
                    </div>
                    <p class='connexion_title'>${node.host}</p>
                    ${stateInput}
                </div>
                <div>
                    <button id='${data.indexOf(node)}_reload' class='list_upSong'><i class="fa-solid fa-rotate-right"></i></button>
                    <button id='${data.indexOf(node)}_delete' class='list_delete'><i class='fa fa-trash'></i></button>
                </div>
            </div>`)

        }

        settings_content.innerHTML = dataToPush.join("")

        const an_dialog = document.getElementById("an_dialog")
        const an_close = document.getElementById("an_close")
        const an_add = document.getElementById("an_create")
        const an_host = document.getElementById("an_host")
        const an_port = document.getElementById("an_port")
        const an_password = document.getElementById("an_password")
        const an_send = document.getElementById("an_send")
        const an_info = document.getElementById("an_info")

        an_add.addEventListener("click", () => {
            an_info.innerHTML = ""
            an_dialog.showModal()
        })

        an_close.addEventListener("click", () => {
            an_info.innerHTML = ""
            an_dialog.close()
        })

        an_send.addEventListener("click", () => {
            an_info.innerHTML = ""


            if(an_host.value != '' && an_port.value != '' && an_password.value != '' ) {
               
              
                var data = {
                    "host":an_host.value.replace(" ", ""),
                    'port': parseInt(an_port.value),
                    "password": an_password.value,
                    "retryAmount": 1
                }
    
                send("NODES/ADD", data)
    
                an_dialog.close()

            } else {
            

                an_info.innerHTML = "Remplissez toutes les cases !"
            }

            

        })

        for(var node of data) {

            let reloadBtn = document.getElementById(data.indexOf(node) + "_reload")
            let deleteBtn = document.getElementById(data.indexOf(node) + "_delete") 
            
            reloadBtn.addEventListener("click", () => {
                send("NODES/RELOAD", data[reloadBtn.id.replace("_reload", "")])

            })

            deleteBtn.addEventListener("click", () => {
                console.log(deleteBtn)
                console.log(data[reloadBtn.id.replace("_reload", "")])
                send("NODES/DELETE", data[reloadBtn.id.replace("_reload", "")])

            })

        }
       
    
    
        
       
         
    }

    



})